api/urls.py
from django.urls import path, include

urlpatterns = [
    path('v1/', include('api.v1.urls'))
]

api/v1/notification/urls.py
from django.urls import path
from api.v1.notification import views

app_name = 'api_notification'

urlpatterns = [
    # client
    path('client/list/', views.ClientListApiView.as_view(), name='client_list'),
    path('client/create/', views.ClientCreateApiView.as_view(), name='client_create'),
    path('client/<int:id>/', views.ClientUpdateApiView.as_view(), name='client_delete_update'),

    # sms
    # pass  ))

    # dispatcher
    path('dispatch/list/', views.DispatcherListApiView.as_view(), name='dispatch_list'),
    path('dispatch/create/', views.DispatcherCreateApiView.as_view(), name='dispatch_create'),
    path('dispatch/<int:id>/', views.DispatcherUpdateApiView.as_view(), name='dispatch_delete_update'),

]

main/urls.py
from django.contrib import admin
from django.urls import path, include
from django.contrib.auth.views import LoginView, LogoutView
from django.conf.urls.static import static

from drf_yasg import openapi
from drf_yasg.views import get_schema_view

from main import settings

schema_view = get_schema_view(
    openapi.Info(
        title="Your API Title",
        default_version='v1',
        description="Your API description",
        terms_of_service="https://www.example.com/terms/",
        contact=openapi.Contact(email="hanry.lucas.001@gmail.com"),
        license=openapi.License(name="BSD License"),
    ),
    public=True,
)

urlpatterns = [

    # AUTH
    path('login/', LoginView.as_view(template_name='login.html'), name='login'),
    path('logout/', LogoutView.as_view(), name='logout'),

    # Apps
    path('', include('notifications.urls')),

    # API
    path('api/', include('api.urls')),

    # django admin
    path('admin/', admin.site.urls),

    # swagger
    path('docs/', include('main.swagger')),
]

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

notifications/urls.py
from django.urls import path
from . import views

app_name = 'notifications'

urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path('client/list/', views.ClientListView.as_view(), name='client_list'),
    path('dispatch/list/', views.DispatchListView.as_view(), name='dispatch_list'),
    path('message/list/', views.MessageListView.as_view(), name='message_list'),
]

notifications/models.py
from django.db import models
from base.models import Base
from django.core.exceptions import ValidationError


def validate_phone_number_format(value):
    if not value.isdigit() or len(value) != 11 or not value.startswith('7'):
        raise ValidationError('Please enter a valid phone number in the format 7XXXXXXXXXX.')


class Client(Base):
    full_name = models.CharField(max_length=255, null=True, blank=True)
    email = models.EmailField(null=True, blank=True)

    phone_number = models.CharField(max_length=11, unique=True, validators=[validate_phone_number_format])
    operator_code = models.CharField(max_length=10)
    tag = models.CharField(max_length=255)
    timezone = models.CharField(max_length=255)

    def __str__(self):
        return f"{self.id} | {self.phone_number}"


class Message(Base):
    STATUS_CHOICES = (
        ('sent', 'Sent'),
        ('pending', 'Pending'),
        ('failed', 'Failed'),
    )

    sent_at = models.DateTimeField(auto_now_add=True)
    status = models.CharField(max_length=255, choices=STATUS_CHOICES)
    dispatch = models.ForeignKey('Dispatch', on_delete=models.CASCADE, related_name='messages')
    client = models.ForeignKey(Client, on_delete=models.CASCADE)

    def __str__(self):
        return f"{self.id} | {self.client} | {self.status}"


class Dispatch(Base):
    title = models.CharField(max_length=255, null=True, blank=True)
    enabled = models.BooleanField(default=True)

    start_date_time = models.DateTimeField()
    end_date_time = models.DateTimeField()
    message = models.TextField()
    operator_code = models.CharField(max_length=10)
    tag = models.CharField(max_length=255)

api/v1/notification/views.py
from rest_framework import generics
from rest_framework.permissions import IsAuthenticated

from notifications.models import Client, Dispatch, Message
from .serializers import ClientSerializer, DispatchSerializer, MessageSerializer


# Client
class ClientListApiView(generics.ListAPIView):
    # permission_classes = [IsAuthenticated]

    serializer_class = ClientSerializer
    queryset = Client.objects.all()


class ClientCreateApiView(generics.CreateAPIView):
    # permission_classes = [IsAuthenticated]

    serializer_class = ClientSerializer
    queryset = Client.objects.all()


class ClientUpdateApiView(generics.RetrieveUpdateDestroyAPIView):
    # permission_classes = [IsAuthenticated]

    serializer_class = ClientSerializer
    queryset = Client.objects.all()
    lookup_url_kwarg = 'id'


# Dispatch
class DispatcherListApiView(generics.ListAPIView):
    # permission_classes = [IsAuthenticated]

    serializer_class = DispatchSerializer
    queryset = Dispatch.objects.all()


class DispatcherCreateApiView(generics.CreateAPIView):
    # permission_classes = [IsAuthenticated]

    serializer_class = DispatchSerializer
    queryset = Dispatch.objects.all()


class DispatcherUpdateApiView(generics.RetrieveUpdateDestroyAPIView):
    # permission_classes = [IsAuthenticated]

    serializer_class = DispatchSerializer
    queryset = Dispatch.objects.all()
    lookup_url_kwarg = 'id'


# Message
class MessageListApiView(generics.ListAPIView):
    # permission_classes = [IsAuthenticated]

    serializer_class = MessageSerializer
    queryset = Dispatch.objects.all()


class MessageCreateApiView(generics.CreateAPIView):
    # permission_classes = [IsAuthenticated]

    serializer_class = MessageSerializer
    queryset = Dispatch.objects.all()


class MessageUpdateApiView(generics.RetrieveUpdateDestroyAPIView):
    # permission_classes = [IsAuthenticated]

    serializer_class = MessageSerializer
    queryset = Dispatch.objects.all()
    lookup_url_kwarg = 'id'

notifications/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic import TemplateView
from django.views.generic import TemplateView, DetailView, ListView
from .models import Client, Dispatch, Message
import pytz


class IndexView(LoginRequiredMixin, TemplateView):
    template_name = 'index.html'


class ClientListView(LoginRequiredMixin, ListView):
    model = Client
    queryset = Client.objects.all()
    template_name = 'notifications/client_list.html'

    def get_context_data(self, *, object_list=None, **kwargs):
        resp = super(ClientListView, self).get_context_data(**kwargs)
        resp['timezones'] = pytz.all_timezones
        return resp


class DispatchListView(LoginRequiredMixin, ListView):
    model = Dispatch
    queryset = Dispatch.objects.all()
    template_name = 'notifications/dispatch_list.html'


class MessageListView(LoginRequiredMixin, ListView):
    model = Message
    queryset = Message.objects.all()
    template_name = 'notifications/message_list.html'

templates/notifications/client_list.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Служба уведомлений - Клиент{% endblock title %}
{% block main %}

    <div class="toolbar mb-n1 pt-3 mb-lg-n3 pt-lg-6" id="kt_toolbar">
        <div id="kt_toolbar_container" class="container-xxl d-flex flex-stack flex-wrap gap-2">
            <div class="page-title d-flex flex-column align-items-start me-3 gap-2">
                <h1 class="d-flex text-dark fw-bolder m-0 fs-3">Клиенты ({{ client_list.count }})</h1>
                <small class="text-gray-500 fs-7 fw-bold my-1"> <a href="/">Главная</a> / Клиент</small>
            </div>
        </div>
    </div>

    <div id="kt_content_container" class="d-flex flex-column-fluid align-items-start container-xxl mb-8">
        <div class="content flex-row-fluid" id="kt_content">
            <div class="card card-flush">
                <div class="card-header align-items-center py-5 gap-2 gap-md-5">
                    <div class="card-title">
                        <div class="d-flex align-items-center position-relative my-1">
                            <input type="text"
                                   class="form-control form-control-solid w-250px ps-14"
                                   placeholder="Поиск"/>
                        </div>
                    </div>
                    <div class="d-flex justify-content-end gap-5">
                        <div class="w-100 mw-150px">
                            <select class="form-select form-select-solid w-150px" data-control="select2"
                                    data-hide-search="true" data-placeholder="Тип мобильного оператора">
                                <option></option>
                                <option value="all">Все</option>
                                <option value="#">(998) MTS</option>
                                <option value="#">(91) Beeline</option>
                                <option value="#">(93) UcELL</option>
                            </select>
                        </div>
                        <a href="#" class="btn btn-primary er px-8" data-bs-toggle="modal"
                           data-bs-target="#add_vehicle">Добавить</a>
                    </div>
                </div>
                <div class="card-body pt-0">
                    <table class="table align-middle table-row-dashed fs-6 gy-5" id="table_vehicle">
                        <thead>
                        <tr class="text-start text-gray-400 fw-bolder fs-7 gs-0">
                            <th class="min-w-150px table-th-pr">И.Ф.О</th>
                            <th class="text-end min-w-100px table-th-pr">Номер телефон</th>
                            <th class="text-end min-w-150px table-th-pr">Почта</th>
                            <th class="text-end min-w-100px table-th-pr">Код оператора</th>
                            <th class="text-end min-w-100px table-th-pr">Тег</th>
                            <th class="text-end min-w-150px table-th-pr">Часовой пояс</th>
                            <th class="text-end min-w-100px table-th-pr">Действия</th>
                        </tr>
                        </thead>
                        <tbody class="fw-bold text-gray-600">
                        {% for client in client_list %}
                            <tr>
                                <td>
                                    <div class="d-flex align-items-center">
                                        <a href="#" class="symbol symbol-50px">
                                            <img src="{% static '/images/default_images/avatar.png' %}"
                                                 class="symbol-label photo"
                                                 alt="image"/>
                                        </a>
                                        <div class="ms-5">
                                            <a href="#"
                                               class="text-gray-800 text-hover-primary fs-5 fw-bolder worker-name"
                                               data-kt-ecommerce-product-filter="product_name">
                                                {{ client.full_name }}
                                            </a>
                                        </div>
                                    </div>
                                </td>
                                <td class="text-end pe-0">
                                    <span class="fw-bolder">+{{ client.phone_number|default_if_none:'Не указан' }}</span>
                                </td>
                                <td class="text-end pe-0">
                                    <span class="fw-bolder">{{ client.email|default_if_none:'Не указан' }}</span>
                                </td>
                                <td class="text-end pe-0" data-order="21">
                                    <span class="fw-bolder">{{ client.operator_code|default_if_none:'Не указан' }}</span>
                                </td>
                                <td class="text-end pe-0" data-order="21">
                                    <span class="fw-bolder">{{ client.tag|default_if_none:'Не указан' }}</span>
                                </td>
                                <td class="text-end pe-0" data-order="21">
                                    <span class="fw-bolder">{{ client.timezone|default_if_none:'Не указан' }}</span>
                                </td>
                                <td class="text-end">
                                    <a data-url="{% url 'api_notification:client_delete_update' client.id %}"
                                       data-bs-toggle="modal"
                                       data-bs-target="#update_vehicle"
                                       class="btn btn-sm btn-icon btn-clear btn-active-light-primary update_vehicle">
                                         <span class="svg-icon svg-icon-2 m-0">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24"
                                                 viewBox="0 0 24 24" fill="none">
                                                <path opacity="0.3" fill-rule="evenodd" clip-rule="evenodd"
                                                      d="M2 4.63158C2 3.1782 3.1782 2 4.63158 2H13.47C14.0155 2 14.278 2.66919 13.8778 3.04006L12.4556 4.35821C11.9009 4.87228 11.1726 5.15789 10.4163 5.15789H7.1579C6.05333 5.15789 5.15789 6.05333 5.15789 7.1579V16.8421C5.15789 17.9467 6.05333 18.8421 7.1579 18.8421H16.8421C17.9467 18.8421 18.8421 17.9467 18.8421 16.8421V13.7518C18.8421 12.927 19.1817 12.1387 19.7809 11.572L20.9878 10.4308C21.3703 10.0691 22 10.3403 22 10.8668V19.3684C22 20.8218 20.8218 22 19.3684 22H4.63158C3.1782 22 2 20.8218 2 19.3684V4.63158Z"
                                                      fill="#123875"></path>
                                                <path d="M10.9256 11.1882C10.5351 10.7977 10.5351 10.1645 10.9256 9.77397L18.0669 2.6327C18.8479 1.85165 20.1143 1.85165 20.8953 2.6327L21.3665 3.10391C22.1476 3.88496 22.1476 5.15129 21.3665 5.93234L14.2252 13.0736C13.8347 13.4641 13.2016 13.4641 12.811 13.0736L10.9256 11.1882Z"
                                                      fill="#123875"></path>
                                                <path d="M8.82343 12.0064L8.08852 14.3348C7.8655 15.0414 8.46151 15.7366 9.19388 15.6242L11.8974 15.2092C12.4642 15.1222 12.6916 14.4278 12.2861 14.0223L9.98595 11.7221C9.61452 11.3507 8.98154 11.5055 8.82343 12.0064Z"
                                                      fill="#123875"></path>
                                            </svg>
                                        </span>
                                    </a>
                                    <a data-url="{% url 'api_notification:client_delete_update' client.id %}"
                                       data-bs-toggle="modal"
                                       data-bs-target="#delete_vehicle"
                                       class="btn btn-sm btn-icon btn-clear btn-active-light-primary delete_vehicle">
                                        <span class="svg-icon svg-icon-3">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="24"
                                                 height="24" viewBox="0 0 24 24" fill="#a51330">
                                                <path d="M5 9C5 8.44772 5.44772 8 6 8H18C18.5523 8 19 8.44772 19 9V18C19 19.6569 17.6569 21 16 21H8C6.34315 21 5 19.6569 5 18V9Z"
                                                      fill="#a51330"></path>
                                                <path opacity="0.5"
                                                      d="M5 5C5 4.44772 5.44772 4 6 4H18C18.5523 4 19 4.44772 19 5V5C19 5.55228 18.5523 6 18 6H6C5.44772 6 5 5.55228 5 5V5Z"
                                                      fill="#a51330">
                                                </path>
                                                <path opacity="0.5"
                                                      d="M9 4C9 3.44772 9.44772 3 10 3H14C14.5523 3 15 3.44772 15 4V4H9V4Z"
                                                      fill="#a51330">
                                                </path>
                                            </svg>
                                        </span>
                                    </a>
                                </td>
                            </tr>
                        {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>

    {% include 'notifications/modals/add_client.html' %}
    {% include 'notifications/modals/update_client.html' %}
    {% include 'notifications/modals/delete_client.html' %}

{% endblock %}


{% block script %}
{% endblock %}

templates/notifications/dispatch_list.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Служба уведомлений - Рассылка{% endblock title %}
{% block main %}

    <div class="toolbar mb-n1 pt-3 mb-lg-n3 pt-lg-6" id="kt_toolbar">
        <div id="kt_toolbar_container" class="container-xxl d-flex flex-stack flex-wrap gap-2">
            <div class="page-title d-flex flex-column align-items-start me-3 gap-2">
                <h1 class="d-flex text-dark fw-bolder m-0 fs-3">Рассылка ({{ dispatch_list.count }})</h1>
                <small class="text-gray-500 fs-7 fw-bold my-1"> <a href="/">Главная</a> / Рассылка</small>
            </div>
        </div>
    </div>

    <div id="kt_content_container" class="d-flex flex-column-fluid align-items-start container-xxl mb-8">
        <div class="content flex-row-fluid" id="kt_content">
            <div class="card card-flush">
                <div class="card-header align-items-center py-5 gap-2 gap-md-5">
                    <div class="card-title">
                        <div class="d-flex align-items-center position-relative my-1">
                            <input type="text" data-table-search="search"
                                   class="form-control form-control-solid w-250px ps-14"
                                   placeholder="Поиск"/>
                        </div>
                    </div>
                    <div class="d-flex justify-content-end gap-5">
                        <div class="w-100 mw-150px">
                            <select class="form-select form-select-solid w-150px" data-control="select2"
                                    data-hide-search="true" data-placeholder="Тип статуса"
                                    data-kt-ecommerce-product-filter="status">
                                <option></option>
                                <option value="all">Все</option>
                                <option value="on">Enabled</option>
                                <option value="off">Disabled</option>
                            </select>
                        </div>
                        <a href="#" class="btn btn-primary er px-8" data-bs-toggle="modal"
                           data-bs-target="#add_vehicle">Добавить</a>
                    </div>
                </div>
                <div class="card-body pt-0">
                    <table class="table align-middle table-row-dashed fs-6 gy-5" id="table_vehicle">
                        <thead>
                        <tr class="text-start text-gray-400 fw-bolder fs-7 gs-0">
                            <th class="text-center min-w-50px table-th-pr">ID</th>
                            <th class="text-end min-w-150px table-th-pr">Наименование</th>
                            <th class="text-end min-w-150px table-th-pr">Дата запуска</th>
                            <th class="text-end min-w-150px table-th-pr">Дата окончания</th>
                            <th class="text-end min-w-200px table-th-pr">Сообщения</th>
                            <th class="text-end min-w-70px table-th-pr">Оператор</th>
                            <th class="text-end min-w-70px table-th-pr">Тег</th>
                            <th class="text-end min-w-100px table-th-pr">Статус</th>
                            <th class="text-end min-w-100px table-th-pr">Действия</th>
                        </tr>
                        </thead>
                        <tbody class="fw-bold text-gray-600">
                        {% for dispatch in dispatch_list %}
                            <tr>
                                <td class="text-md-center pe-0">
                                    <span class="fw-bolder">{{ dispatch.id }}</span>
                                </td>
                                <td class="text-end pe-0" data-order="21">
                                    <span class="fw-bolder message-cell">{{ dispatch.title|default_if_none:'Не указан' }}</span>
                                </td>
                                <td class="text-end pe-0">
                                    <span class="fw-bolder">{{ dispatch.start_date_time|default_if_none:'Не указан'|date:'d F Y, H:i' }}</span>
                                </td>
                                <td class="text-end pe-0" data-order="21">
                                    <span class="fw-bolder">{{ dispatch.end_date_time|default_if_none:'Не указан'|date:'d F Y, H:i' }}</span>
                                </td>
                                <td class="text-end pe-0" data-order="21">
                                    <span class="fw-bolder message-cell">{{ dispatch.message|default_if_none:'Не указан' }}</span>
                                </td>
                                <td class="text-end pe-0" data-order="21">
                                    <span class="fw-bolder">{{ dispatch.operator_code|default_if_none:'Не указан' }}</span>
                                </td>
                                <td class="text-end pe-0" data-order="21">
                                    <span class="fw-bolder">{{ dispatch.tag|default_if_none:'Не указан' }}</span>
                                </td>
                                <td class="text-end pe-0" data-order="21">
                                    <span class="fw-bolder">{% if dispatch.enabled %}Enabled{% else %}
                                        Disabled{% endif %}</span>
                                </td>
                                <td class="text-end">
                                    <a data-url="{% url 'api_notification:dispatch_delete_update' dispatch.id %}"
                                       data-bs-toggle="modal"
                                       data-bs-target="#update_vehicle"
                                       class="btn btn-sm btn-icon btn-clear btn-active-light-primary update_vehicle">
                                         <span class="svg-icon svg-icon-2 m-0">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24"
                                                 viewBox="0 0 24 24" fill="none">
                                                <path opacity="0.3" fill-rule="evenodd" clip-rule="evenodd"
                                                      d="M2 4.63158C2 3.1782 3.1782 2 4.63158 2H13.47C14.0155 2 14.278 2.66919 13.8778 3.04006L12.4556 4.35821C11.9009 4.87228 11.1726 5.15789 10.4163 5.15789H7.1579C6.05333 5.15789 5.15789 6.05333 5.15789 7.1579V16.8421C5.15789 17.9467 6.05333 18.8421 7.1579 18.8421H16.8421C17.9467 18.8421 18.8421 17.9467 18.8421 16.8421V13.7518C18.8421 12.927 19.1817 12.1387 19.7809 11.572L20.9878 10.4308C21.3703 10.0691 22 10.3403 22 10.8668V19.3684C22 20.8218 20.8218 22 19.3684 22H4.63158C3.1782 22 2 20.8218 2 19.3684V4.63158Z"
                                                      fill="#123875"></path>
                                                <path d="M10.9256 11.1882C10.5351 10.7977 10.5351 10.1645 10.9256 9.77397L18.0669 2.6327C18.8479 1.85165 20.1143 1.85165 20.8953 2.6327L21.3665 3.10391C22.1476 3.88496 22.1476 5.15129 21.3665 5.93234L14.2252 13.0736C13.8347 13.4641 13.2016 13.4641 12.811 13.0736L10.9256 11.1882Z"
                                                      fill="#123875"></path>
                                                <path d="M8.82343 12.0064L8.08852 14.3348C7.8655 15.0414 8.46151 15.7366 9.19388 15.6242L11.8974 15.2092C12.4642 15.1222 12.6916 14.4278 12.2861 14.0223L9.98595 11.7221C9.61452 11.3507 8.98154 11.5055 8.82343 12.0064Z"
                                                      fill="#123875"></path>
                                            </svg>
                                        </span>
                                    </a>
                                    <a data-url="{% url 'api_notification:dispatch_delete_update' dispatch.id %}"
                                       data-bs-toggle="modal"
                                       data-bs-target="#delete_vehicle"
                                       class="btn btn-sm btn-icon btn-clear btn-active-light-primary delete_vehicle">
                                        <span class="svg-icon svg-icon-3">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="24"
                                                 height="24" viewBox="0 0 24 24" fill="#a51330">
                                                <path d="M5 9C5 8.44772 5.44772 8 6 8H18C18.5523 8 19 8.44772 19 9V18C19 19.6569 17.6569 21 16 21H8C6.34315 21 5 19.6569 5 18V9Z"
                                                      fill="#a51330"></path>
                                                <path opacity="0.5"
                                                      d="M5 5C5 4.44772 5.44772 4 6 4H18C18.5523 4 19 4.44772 19 5V5C19 5.55228 18.5523 6 18 6H6C5.44772 6 5 5.55228 5 5V5Z"
                                                      fill="#a51330">
                                                </path>
                                                <path opacity="0.5"
                                                      d="M9 4C9 3.44772 9.44772 3 10 3H14C14.5523 3 15 3.44772 15 4V4H9V4Z"
                                                      fill="#a51330">
                                                </path>
                                            </svg>
                                        </span>
                                    </a>
                                </td>
                            </tr>
                        {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>

    {% include 'notifications/modals/add_dispatch.html' %}
    {% include 'notifications/modals/update_dispatch.html' %}
    {% include 'notifications/modals/delete_dispatch.html' %}

{% endblock %}


{% block script %}

{% endblock %}

templates/notifications/message_list.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Служба уведомлений - Cообщение{% endblock title %}
{% block main %}

    <div class="toolbar mb-n1 pt-3 mb-lg-n3 pt-lg-6" id="kt_toolbar">
        <div id="kt_toolbar_container" class="container-xxl d-flex flex-stack flex-wrap gap-2">
            <div class="page-title d-flex flex-column align-items-start me-3 gap-2">
                <h1 class="d-flex text-dark fw-bolder m-0 fs-3">Cообщение ({{ message_list.count }})</h1>
                <small class="text-gray-500 fs-7 fw-bold my-1"> <a href="/">Главная</a> / Cообщение</small>
            </div>
        </div>
    </div>

    <div id="kt_content_container" class="d-flex flex-column-fluid align-items-start container-xxl mb-8">
        <div class="content flex-row-fluid" id="kt_content">
            <div class="card card-flush">
                <div class="card-header align-items-center py-5 gap-2 gap-md-5">
                    <div class="card-title">
                        <div class="d-flex align-items-center position-relative my-1">
                            <input type="text" data-table-search="search"
                                   class="form-control form-control-solid w-250px ps-14"
                                   placeholder="Поиск"/>
                        </div>
                    </div>
                    <div class="d-flex justify-content-end gap-5">
                        <div class="w-100 mw-150px">
                            <select class="form-select form-select-solid w-150px" data-control="select2"
                                    data-hide-search="true" data-placeholder="Тип статуса"
                                    data-kt-ecommerce-product-filter="status">
                                <option></option>
                                <option value="all">Все</option>
                                <option value="sent">Успешный</option>
                                <option value="failed">Неуспешный</option>
                            </select>
                        </div>
                    </div>
                </div>
                <div class="card-body pt-0">
                    <table class="table align-middle table-row-dashed fs-6 gy-5" id="table_vehicle">
                        <thead>
                        <tr class="text-start text-gray-400 fw-bolder fs-7 gs-0">
                            <th class="text-center min-w-50px table-th-pr">ID</th>
                            <th class="text-end min-w-150px table-th-pr">Дата отправки</th>
                            <th class="text-end min-w-150px table-th-pr">Cтатус отправки</th>
                            <th class="text-end min-w-200px table-th-pr">ID рассылки</th>
                            <th class="text-end min-w-150px table-th-pr">ID клиента</th>
                        </tr>
                        </thead>
                        <tbody class="fw-bold text-gray-600">
                        {% for message in message_list %}
                            <tr>
                                <td class="text-md-center pe-0">
                                    <span class="fw-bolder">{{ message.id }}</span>
                                </td>
                                <td class="text-end pe-0">
                                    <span class="fw-bolder">{{ message.sent_at|default_if_none:'Не указан'|date:'d F Y, H:i' }}</span>
                                </td>
                                <td class="text-end pe-0" data-order="21">
                                    <span class="fw-bolder">{{ message.status|default_if_none:'Не указан' }}</span>
                                </td>
                                <td class="text-end pe-0" data-order="21">
                                    <span class="fw-bolder message-cell">{{ message.dispatch.id }} {{ message.dispatch.title|default_if_none:'(Не указан)' }}</span>
                                </td>
                                <td class="text-end pe-0" data-order="21">
                                    <span class="fw-bolder message-cell">{{ message.client.id }} {{ message.client.full_name|default_if_none:'(Не указан)' }}</span>
                                </td>
                            </tr>
                        {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>


{% endblock %}


{% block script %}
{% endblock %}